function  [dxdt_fnc,xgrd,f0,t_op,tau_op]=xUL_f2d_su(imd, cnm, ido_bwd)
% general setup for xMD_f2d_t0tau
%
% Input
%     imd:         imd_t0tau or imd_ttau0  
%     cnm.mdl/exp: name for model and experiments     
%     ido_bwd:     ido or idont for backward
% Output
%     from inpput file
%       dxdt_fnc:/   function mame
%       xgrd:            
%       f0:          initial condition for the flow
%     formatted
%       t_op, tau_op output for t and tau for both imd_t0tau,ttau0
%
% Written by Kayo Ide (University of Maryland)
% 2015 August

%% global
% general
global Nd
global ido idont
% 
global imd_t0tau imd_ttau0
%
global dnm_op 
global dfnm_op
global dfnm_op_avi
%
global dxdt_prm  
global plt_prm
%
global ixMf_strt ixMf_end

%% initialization: ic for flow
f0=[];

%% read input
fnm_ip=['xUL_f' int2str(Nd) 'd_ip_' cnm.mdl '_' cnm.exp]; 
eval(fnm_ip);

%%  id for xML strt and end
Np=1;
for nd=1:Nd; Np=Np*xgrd(nd).n; end
ixMf_strt.x=              1+Np*[0 Nd-1]; 
ixMf_end.x =                Np*[1 Nd];
ixMf_strt.M=ixMf_strt.x(Nd)+Np;
ixMf_end.M =ixMf_end.x(Nd) +Np;
ixMf_strt.f=ixMf_end.M    +1;
ixMf_end.f =ixMf_strt.f   -1+numel(f0);

%% setup directory 
if(imd-imd_t0tau==0);
    dnm_op.bfcs=[dnm_op.bfcs '_t0' num2str(t0)];
    dnm_op.bfcs=[dnm_op.bfcs 'tau' num2str(t0_tau(1)) num2str(t0_tau(1))];
    dnm_op.bfcs=[dnm_op.bfcs 'dtau' num2str(t0_tau(1)-t0_tau(1))];
    tau_op=t0_tau;
    t_op=t0*ones(size(tau_op));
else;
    dnm_op.bfcs=[dnm_op.bfcs '_tau0' num2str(tau0)];
    dnm_op.bfcs=[dnm_op.bfcs 't' num2str(t_tau0(1)) num2str(t_tau0(1))];
    dnm_op.bfcs=[dnm_op.bfcs 'dt' num2str(t_tau0(1)-t_tau0(1))];
    t_op=t_tau0;
    tau_op=tau0*ones(size(t_op));
end
if(ido_bwd-ido~=0); dnm_op.bfcs=[dnm_op.bfcs 'fwd']; end
dnm_op.bfcs=[dnm_op.bfcs '_grd' num2str(xgrd(1).mx-xgrd(1).mn) 'x' ...
    num2str(xgrd(2).mx-xgrd(2).mn)];
dnm_op.bfcs=[dnm_op.bfcs '_' int2str(xgrd(1).n) 'x' int2str(xgrd(2).n)];

%% setup directory & file names
dfnm_op.x=[dnm_op.bfcs '/' cnm.mdl '_' cnm.exp '_x.dat' ];
dfnm_op.M=[dnm_op.bfcs '/' cnm.mdl '_' cnm.exp '_M.dat' ];
dfnm_op.L=[dnm_op.bfcs '/' cnm.mdl '_' cnm.exp '_DLE.dat' ];
dfnm_op.f=[dnm_op.bfcs '/' cnm.mdl '_' cnm.exp '_f.dat' ];
dfnm_op_avi=[dnm_op.bfcs '/' cnm.mdl '_' cnm.exp '.avi' ];

return