function xUL_f2d_x2D(ido_bwd)
% xUL_f2d_x2D: given x, compute DLE
%   x: given in dfnm_op.M
%   DLE:  to be saved in dfnm_op.DLE
%
% Written by Kayo Ide (University of Maryland)
% 2015 August

%% global
% system input (passed on)
global ido idont
global Nd
%
global dfnm_op

%% setup
cpu0=cputime;
% x data
load(dfnm_op.x,'-mat');
% tau
Ktau=length(tau_op);
% number of grid and dx
Ngrd=size(xfwd,1);
dx=zeros(Nd,1);
for nd=1:Nd; 
    dx(nd)=(xgrd_op(nd).mx-xgrd_op(nd).mn)./(xgrd_op(nd).n-1);
end
% grid id
ipl=2:xgrd_op(2).n-1;  ipr=(xgrd_op(1).n-1)*xgrd_op(2).n+ipl;
ipb=1+xgrd_op(2).n*[1:xgrd_op(1).n-2];  ipt=xgrd_op(2).n*[2:xgrd_op(1).n-1];
ip=[]; 
for n=2:1:xgrd_op(1).n -1
    ip=[ip ((n-1)*xgrd_op(2).n +ipl)];
end
ip_xm1=ip-xgrd_op(2).n;  ip_xp1=ip+xgrd_op(2).n;
ip_xm2=ip-1;             ip_xp2=ip+1;
% DLW
DLEfwd=zeros(Ngrd,Ktau); 
if(ido_bwd-ido==0); DLEbwd=DLEfwd;
else; DLEbwd=0;
end

%% DLE computation
for k=1:Ktau
    if(abs(tau_op(k))~=0); 
        %- fwd
        x1=xfwd(:,k,1); x2=xfwd(:,k,2); 
        %
        d11=x1(ip_xp1)-x1(ip_xm1); d12=x1(ip_xp2)-x1(ip_xm2);
        d21=x2(ip_xp1)-x2(ip_xm1); d22=x2(ip_xp2)-x2(ip_xm2); 
        M11=d11./dx(1);               M12=d12./dx(2); 
        M21=d21./dx(1);               M22=d22./dx(2);
        % for DLE 
        W11=M11.^2+M21.^2; W12=M11.*M12+M21.*M22; W22=M12.^2+M22.^2;
        eW=((W11+W22)+sqrt((W11-W22).^2+4*W12.^2))/2;
        DLEfwd(ip,k)=log(eW)/tau_op(k);   
        DLEfwd(ipl,k)=DLEfwd(ipl+xgrd_op(2).n,k);
        DLEfwd(ipr,k)=DLEfwd(ipr-xgrd_op(2).n,k);
        DLEfwd(ipb,k)=DLEfwd(ipb+1,k);    
        DLEfwd(ipt,k)=DLEfwd(ipt-1,k);  
        DLEfwd(1,k)=DLEfwd(2,k); DLEfwd(xgrd_op(2).n,k)=DLEfwd(xgrd_op(2).n-1,k);
        DLEfwd(1+xgrd_op(2).n*(xgrd_op(1).n-1),k)=DLEfwd(2+xgrd_op(2).n*(xgrd_op(1).n-1),k);
        DLEfwd(Ngrd,k)=DLEfwd(Ngrd-1,k);
        % bwd- 
        if(ido_bwd-ido==0); 
            x1=xbwd(:,k,1); x2=xbwd(:,k,2); 
            %
            d11=x1(ip_xp1)-x1(ip_xm1); d12=x1(ip_xp2)-x1(ip_xm2);
            d21=x2(ip_xp1)-x2(ip_xm1); d22=x2(ip_xp2)-x2(ip_xm2); 
            M11=d11./dx(1);               M12=d12./dx(2); 
            M21=d21./dx(1);               M22=d22./dx(2);
            % for DLE
            W11=M11.^2+M21.^2; W12=M11.*M12+M21.*M22; W22=M12.^2+M22.^2;
            eW=((W11+W22)+sqrt((W11-W22).^2+4*W12.^2))/2;
            DLEbwd(ip,k)=log(eW)/tau_op(k);   
            DLEbwd(ipl,k)=DLEbwd(ipl+xgrd_op(2).n,k);
            DLEbwd(ipr,k)=DLEbwd(ipr-xgrd_op(2).n,k);
            DLEbwd(ipb,k)=DLEbwd(ipb+1,k);    
            DLEbwd(ipt,k)=DLEbwd(ipt-1,k);  
            DLEbwd(1,k)=DLEbwd(2,k); DLEbwd(xgrd_op(2).n,k)=DLEbwd(xgrd_op(2).n-1,k);
            DLEbwd(1+xgrd_op(2).n*(xgrd_op(1).n-1),k)=DLEbwd(2+xgrd_op(2).n*(xgrd_op(1).n-1),k);
            DLEbwd(Ngrd,k)=DLEbwd(Ngrd-1,k);   
        end
    end
end

%% output
save(dfnm_op.L,'-mat','t_op','tau_op','xgrd_op','DLEfwd','DLEbwd')

fprintf('\n        cpu for DLE=%10.2f',cputime-cpu0);

return